import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AssuredWorkloadsWorkloadConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#billing_account AssuredWorkloadsWorkload#billing_account}.
     *
     * @stability stable
     */
    readonly billingAccount: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#compliance_regime AssuredWorkloadsWorkload#compliance_regime}.
     *
     * @stability stable
     */
    readonly complianceRegime: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#display_name AssuredWorkloadsWorkload#display_name}.
     *
     * @stability stable
     */
    readonly displayName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#labels AssuredWorkloadsWorkload#labels}.
     *
     * @stability stable
     */
    readonly labels?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#location AssuredWorkloadsWorkload#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#organization AssuredWorkloadsWorkload#organization}.
     *
     * @stability stable
     */
    readonly organization: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#provisioned_resources_parent AssuredWorkloadsWorkload#provisioned_resources_parent}.
     *
     * @stability stable
     */
    readonly provisionedResourcesParent?: string;
    /**
     * kms_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#kms_settings AssuredWorkloadsWorkload#kms_settings}
     *
     * @stability stable
     */
    readonly kmsSettings?: AssuredWorkloadsWorkloadKmsSettings[];
    /**
     * resource_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#resource_settings AssuredWorkloadsWorkload#resource_settings}
     *
     * @stability stable
     */
    readonly resourceSettings?: AssuredWorkloadsWorkloadResourceSettings[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#timeouts AssuredWorkloadsWorkload#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: AssuredWorkloadsWorkloadTimeouts;
}
/**
 * @stability stable
 */
export declare class AssuredWorkloadsWorkloadResources extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get resourceId(): number;
    /**
     * @stability stable
     */
    get resourceType(): string;
}
/**
 * @stability stable
 */
export interface AssuredWorkloadsWorkloadKmsSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#next_rotation_time AssuredWorkloadsWorkload#next_rotation_time}.
     *
     * @stability stable
     */
    readonly nextRotationTime: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#rotation_period AssuredWorkloadsWorkload#rotation_period}.
     *
     * @stability stable
     */
    readonly rotationPeriod: string;
}
/**
 * @stability stable
 */
export interface AssuredWorkloadsWorkloadResourceSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#resource_id AssuredWorkloadsWorkload#resource_id}.
     *
     * @stability stable
     */
    readonly resourceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#resource_type AssuredWorkloadsWorkload#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType?: string;
}
/**
 * @stability stable
 */
export interface AssuredWorkloadsWorkloadTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#create AssuredWorkloadsWorkload#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#delete AssuredWorkloadsWorkload#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html#update AssuredWorkloadsWorkload#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html google_assured_workloads_workload}.
 *
 * @stability stable
 */
export declare class AssuredWorkloadsWorkload extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/google/r/assured_workloads_workload.html google_assured_workloads_workload} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AssuredWorkloadsWorkloadConfig);
    private _billingAccount;
    /**
     * @stability stable
     */
    get billingAccount(): string;
    /**
     * @stability stable
     */
    set billingAccount(value: string);
    /**
     * @stability stable
     */
    get billingAccountInput(): string;
    private _complianceRegime;
    /**
     * @stability stable
     */
    get complianceRegime(): string;
    /**
     * @stability stable
     */
    set complianceRegime(value: string);
    /**
     * @stability stable
     */
    get complianceRegimeInput(): string;
    /**
     * @stability stable
     */
    get createTime(): string;
    private _displayName;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    get displayNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _labels?;
    /**
     * @stability stable
     */
    get labels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set labels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetLabels(): void;
    /**
     * @stability stable
     */
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    /**
     * @stability stable
     */
    get name(): string;
    private _organization;
    /**
     * @stability stable
     */
    get organization(): string;
    /**
     * @stability stable
     */
    set organization(value: string);
    /**
     * @stability stable
     */
    get organizationInput(): string;
    private _provisionedResourcesParent?;
    /**
     * @stability stable
     */
    get provisionedResourcesParent(): string;
    /**
     * @stability stable
     */
    set provisionedResourcesParent(value: string);
    /**
     * @stability stable
     */
    resetProvisionedResourcesParent(): void;
    /**
     * @stability stable
     */
    get provisionedResourcesParentInput(): string | undefined;
    /**
     * @stability stable
     */
    resources(index: string): AssuredWorkloadsWorkloadResources;
    private _kmsSettings?;
    /**
     * @stability stable
     */
    get kmsSettings(): AssuredWorkloadsWorkloadKmsSettings[];
    /**
     * @stability stable
     */
    set kmsSettings(value: AssuredWorkloadsWorkloadKmsSettings[]);
    /**
     * @stability stable
     */
    resetKmsSettings(): void;
    /**
     * @stability stable
     */
    get kmsSettingsInput(): AssuredWorkloadsWorkloadKmsSettings[] | undefined;
    private _resourceSettings?;
    /**
     * @stability stable
     */
    get resourceSettings(): AssuredWorkloadsWorkloadResourceSettings[];
    /**
     * @stability stable
     */
    set resourceSettings(value: AssuredWorkloadsWorkloadResourceSettings[]);
    /**
     * @stability stable
     */
    resetResourceSettings(): void;
    /**
     * @stability stable
     */
    get resourceSettingsInput(): AssuredWorkloadsWorkloadResourceSettings[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AssuredWorkloadsWorkloadTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AssuredWorkloadsWorkloadTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AssuredWorkloadsWorkloadTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
